/* Generated By:JavaCC: Do not edit this line. FilterExpressionParser.java */
package org.ow2.sirocco.cloudmanager.core.util;

import java.lang.StringBuffer;
import java.io.StringReader;
import java.io.Reader;

public class FilterExpressionParser implements FilterExpressionParserConstants {

    private StringBuffer jpqlQuery;  // internal SQL representation.
    private String variableName;

    public FilterExpressionParser(String s, String variableName)
    {
        this((Reader)(new StringReader(s)));
        jpqlQuery = new StringBuffer();
        this.variableName=variableName;
    }

    public String getQuery()
    {
        return jpqlQuery.toString();
    }

    public static void main(String args[])
    {
        try
        {
                String query = args[0];
                FilterExpressionParser parser = new FilterExpressionParser(query,"p");
                parser.parse();
                System.out.println("\u005cnJPQL Query: " + parser.getQuery());
        }
        catch(Exception e)
        {
                e.printStackTrace();
        }
    }

/** 
 *  Top level
 */
  final public void parse() throws ParseException {
    expression();
    jj_consume_token(0);
                jpqlQuery.insert(0,"(");
                jpqlQuery.append(")");
  }

  final public void expression() throws ParseException {
    queryTerm();
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AND:
      case OR:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AND:
        jj_consume_token(AND);
                  jpqlQuery.append(" AND ");
        break;
      case OR:
        jj_consume_token(OR);
                  jpqlQuery.append(" OR ");
        break;
      default:
        jj_la1[1] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      queryTerm();
    }
  }

  final public void queryTerm() throws ParseException {
        Token tAttribute, tComparator, tComparand;
        String sComparand;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PROPERTY:
    case STRING:
    case SINGLE_QUOTED_STRING:
    case DOUBLE_QUOTED_STRING:
    case INTEGER:
      compTerm();
      break;
    case LPAREN:
      jj_consume_token(LPAREN);
          jpqlQuery.append("(");
      expression();
      jj_consume_token(RPAREN);
          jpqlQuery.append(")");
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void compTerm() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING:
      attrValueCompTerm();
      break;
    case SINGLE_QUOTED_STRING:
    case DOUBLE_QUOTED_STRING:
    case INTEGER:
      valueAttrCompTerm();
      break;
    case PROPERTY:
      propExpr();
      break;
    default:
      jj_la1[3] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void attrValueCompTerm() throws ParseException {
        Token tAttribute, tComparator, tComparand;
    tAttribute = jj_consume_token(STRING);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EQUALS:
      tComparator = jj_consume_token(EQUALS);
      break;
    case NOTEQUAL:
      tComparator = jj_consume_token(NOTEQUAL);
      break;
    case GT:
      tComparator = jj_consume_token(GT);
      break;
    case GE:
      tComparator = jj_consume_token(GE);
      break;
    case LT:
      tComparator = jj_consume_token(LT);
      break;
    case LE:
      tComparator = jj_consume_token(LE);
      break;
    default:
      jj_la1[4] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SINGLE_QUOTED_STRING:
      tComparand = jj_consume_token(SINGLE_QUOTED_STRING);
      break;
    case DOUBLE_QUOTED_STRING:
      tComparand = jj_consume_token(DOUBLE_QUOTED_STRING);
      break;
    case INTEGER:
      tComparand = jj_consume_token(INTEGER);
      break;
    default:
      jj_la1[5] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                jpqlQuery.append(" ").append(variableName).append(".").append(tAttribute.image).append(" ").append(tComparator.image);
                jpqlQuery.append(" ").append(tComparand.image).append(" ");
  }

  final public void valueAttrCompTerm() throws ParseException {
        Token tAttribute, tComparator, tComparand;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SINGLE_QUOTED_STRING:
      tComparand = jj_consume_token(SINGLE_QUOTED_STRING);
      break;
    case DOUBLE_QUOTED_STRING:
      tComparand = jj_consume_token(DOUBLE_QUOTED_STRING);
      break;
    case INTEGER:
      tComparand = jj_consume_token(INTEGER);
      break;
    default:
      jj_la1[6] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EQUALS:
      tComparator = jj_consume_token(EQUALS);
      break;
    case NOTEQUAL:
      tComparator = jj_consume_token(NOTEQUAL);
      break;
    case GT:
      tComparator = jj_consume_token(GT);
      break;
    case GE:
      tComparator = jj_consume_token(GE);
      break;
    case LT:
      tComparator = jj_consume_token(LT);
      break;
    case LE:
      tComparator = jj_consume_token(LE);
      break;
    default:
      jj_la1[7] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    tAttribute = jj_consume_token(STRING);
                jpqlQuery.append(" ").append(tComparand.image);
                jpqlQuery.append(" ").append(tComparator.image).append(" ").append(variableName).append(".").append(tAttribute.image).append(" ");
  }

  final public void propExpr() throws ParseException {
        Token tPropKey, tComparator, tComparand;
    jj_consume_token(PROPERTY);
    jj_consume_token(LBRACKET);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SINGLE_QUOTED_STRING:
      tPropKey = jj_consume_token(SINGLE_QUOTED_STRING);
      break;
    case DOUBLE_QUOTED_STRING:
      tPropKey = jj_consume_token(DOUBLE_QUOTED_STRING);
      break;
    default:
      jj_la1[8] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(RBRACKET);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EQUALS:
      tComparator = jj_consume_token(EQUALS);
      break;
    case NOTEQUAL:
      tComparator = jj_consume_token(NOTEQUAL);
      break;
    case GT:
      tComparator = jj_consume_token(GT);
      break;
    case GE:
      tComparator = jj_consume_token(GE);
      break;
    case LT:
      tComparator = jj_consume_token(LT);
      break;
    case LE:
      tComparator = jj_consume_token(LE);
      break;
    default:
      jj_la1[9] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SINGLE_QUOTED_STRING:
      tComparand = jj_consume_token(SINGLE_QUOTED_STRING);
      break;
    case DOUBLE_QUOTED_STRING:
      tComparand = jj_consume_token(DOUBLE_QUOTED_STRING);
      break;
    default:
      jj_la1[10] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                jpqlQuery.append(" ").append(variableName).append(".properties[").append(tPropKey.image).append("] ").append(tComparator.image);
                jpqlQuery.append(" ").append(tComparand.image).append(" ");
  }

  /** Generated Token Manager. */
  public FilterExpressionParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[11];
  static private int[] jj_la1_0;
  static {
      jj_la1_init_0();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x60,0x60,0x3c8080,0x3c8000,0x7e00,0x380000,0x380000,0x7e00,0x180000,0x7e00,0x180000,};
   }

  /** Constructor with InputStream. */
  public FilterExpressionParser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public FilterExpressionParser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new FilterExpressionParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  /** Constructor. */
  public FilterExpressionParser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new FilterExpressionParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  /** Constructor with generated Token Manager. */
  public FilterExpressionParser(FilterExpressionParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(FilterExpressionParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[22];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 11; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 22; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

}
